% gpReadMouseTest.m
% It is exactly like gpReadMouseTest.c, but it does not properly work
% (Octave 2.1.49), contrary its C counterpart. It somehow block ... 
% see the other .m file, which demonstrates that Octave does not block
% if "set print" is issued after the "print MOUSE_*" command. Why?!

gpinName='./cau'
[err, msg]=mkfifo(gpinName, 6*8*8); % 0600
if err != 0
%    perror('bla', err);
    unlink(gpinName);
    return;
end

gp = popen('gnuplot', 'w');
if gp == -1
    pclose(gp)
    return
end

fprintf('Connected to gnuplot.\n');

% Init mouse and redirect all gnuplot printings to our FIFO
fprintf(gp, 'set mouse; set print \"%s\"\n', gpinName);
fflush(gp);

% Sometimes it was necessary to print \n from gnuplot to avoid a block.
%   Probably it is no more necessary.
%#if 0
%fprintf(gp, "print \"\\n\"\n");
%fflush(gp);
%#endif

% Open the FIFO (where gnuplot is writing to) for reading.
gpin = fopen(gpinName, 'r');
if gpin == -1
    pclose(gp);
    return
end

fprintf('FIFO open for reading...\n');


% Now do the work.
fprintf(gp, 'plot sin(x)\n');
fflush(gp);

% /* Do it 5 times. */
%for (n=0; n<5; n++)
n=1
    fprintf('\n%i/5. -- Click anywhere in the graph by mouse button 1.\n', n+1);
    fprintf(gp, 'pause mouse "Click mouse!"\n');
    fflush(gp);

    % Let gnuplot write to coordinates values (to the FIFO).
    fprintf(gp, 'print MOUSE_X, MOUSE_Y, MOUSE_BUTTON\n');
    fflush(gp);

    % Read something from the FIFO.
    a=fgets(gpin,20)
%    fscanf(gpin, "%f %f bd", &mx, &my, &mb);
%    printf("You pressed mouse button %d at x=%f y=%f\n", mb, mx, my);
%
% enf

fclose(gpin);
pclose(gp);
unlink (gpinName);

