# This demo program works OK.
# It writes which mouse button and where you have pressed on the graph.

x=0:0.01:4*pi; y=sin(x);
plot(x,y);

gpinName=sprintf('./OctGnuplot%i', getpid);
[err, msg]=mkfifo(gpinName, 6*8*8); % 6*8*8) % 0600
graw(['set print "', gpinName, '";\n']);

gpin=fopen(gpinName,'r')

fprintf(stdout, 'Octave says: Click mouse now!\n');
graw('pause mouse "Gnuplot says: Click mouse!"\n');
graw('print MOUSE_X, MOUSE_Y, MOUSE_BUTTON\n');
graw('set print\n'); % close output file, otherwise all blocks (why?!)

% Now read from fifo
%a=fgets(gpin,999) % for testing -- show the whole line
[mx, my, mb, count]=fscanf(gpin, '%f %f %d', 'C')
printf('You pressed mouse button %d at x=%f y=%f\n', mb, mx, my);

fclose(gpin);
unlink (gpinName);
